# No path to perl or
# chmoding needed for this file
###
#######################################################
#		Alias Mail v1.01
#     
#    	Created by Solution Scripts
# 		Email: solutions@solutionscripts.com
#		Web: http://alias-mail.com
#
#######################################################
#
#
# COPYRIGHT NOTICE:
#
# Copyright 1999 Solution Scripts  All Rights Reserved.
#
# Selling the code for this program without prior written consent is
# expressly forbidden. In all cases
# copyright and header must remain intact.
#
#######################################################

## FREQ. USED ADMIN ROUTINES ##

sub initalize {

$version = "1.01";

@char_set = ('a'..'z','0'..'9');

$time = time;

# SET FILES #
$files::admin = "admin.cgi";
$files::setup = "admin_setup.cgi";

# ADMIN ACCESS #
@admin_access = ('ALL ACCESS','config','accounts','onhold','html','email');

## GET PASSWORD ##
$passwords=0;
if ($Config::path) {
	if ( -e "$Config::path/password.txt") {
		$Config::password=1;
		open (VARIABLES, "$Config::path/password.txt") || &error("Error reading password.txt");
		@admin_users = <VARIABLES>;
		close (VARIABLES);
		if (@admin_users) { $passwords=1; }
	}
	
	unless (-e "$Config::path/accounts") {
		mkdir("$Config::path/accounts", 0777) || &error("Creating folder $Config::path/accounts");
		chmod(0777,"$Config::path/accounts");
		foreach $ch(@char_set) {
			mkdir("$Config::path/accounts/$ch", 0777) || &error("Creating folder $Config::path/accounts/$ch");
			chmod(0777,"$Config::path/accounts/$ch");			
		}
	}
}

$vari_top = 85;

# GET NAME O SCRIPT #
my $cgi_url = $ENV{'REQUEST_URI'};
my ($dirpath,$filename) = ($cgi_url =~ /^((?:.*[:\\\/])?)(.*)/);

$cgiurl = $ENV{'SCRIPT_NAME'};

$query=$ENV{'QUERY_STRING'};

$something_in=0;

if ($query) { @pairs=split(/&/,$query); }
else {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);
}	
foreach $pair (@pairs) {
	$something_in=1;
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	if ($INPUT{$name}) { $INPUT{$name} = $INPUT{$name}.",".$value; }
	else { $INPUT{$name} = $value; }

}


foreach $key (keys(%ENV)) {
#		print "$key - $ENV{$key}<BR>";
	}

# CHECK SETUP #
my $error=0;
unless ($Config::password) { $error=1; }
unless ($Config::name) { $error=1; }
unless ($Config::path) { $error=1; }
unless ($Config::mime_path) { $error=1; }
unless ($Config::url_cgi) { $error=1; }
unless ($Config::url_img) { $error=1; }
unless ($Config::url_mime) { $error=1; }
unless ($Config::mail_prog) { $error=1; }

## IF WE NEED SET UP FORWARD TO CORRECT CGI ##
if ($error) {
   if ($filename ne $files::setup) {
      &location('admin_setup.cgi');
   }
   ## SUBMITTING SET UP ##
   elsif ($INPUT{'setup_check'}) {
		print "Content-type: text/html\n\n";
		$p_header=1;

      &setup_check;
   }
   ## SET UP FORM ##
   else {
	unless($p_header) { 
		print "Content-type: text/html\n\n";
		$p_header=1;
	}
   	&Header(0);
      &setup;
   }
}

unless ($something_in) { &print_login; } ## SEND TO LOGIN SCREEN ##
if ($INPUT{'inital'}) { &inital_log; }
if ($INPUT{'logout'}) { &logout; }
&log; ## VERIFY USER AND COOKIE ##

return;
}

###### SET NEW COOKIE ######
sub inital_log {

$username = $INPUT{'username'};

open( ADMIN, ">$Config::path/password.txt") || &error("Writing to $Config::path/password.txt");

foreach $user(@admin_users) {
	chomp($user);
	@user_data=split(/\|/,$user);
	if ($INPUT{'username'} eq $user_data[0]) {
		
		$newpassword = crypt($INPUT{'password'},$user_data[1]);
		
		unless ($newpassword eq $user_data[1]) {
			$wrong_password=1;
			print ADMIN "$user\n";
			next;
		}
		else { 
			$right_password=1;
		}	
		## GENERATE RANDOM SESSION VARIABLE ##
		srand($time);
		$session ="";
		@passset = ('a'..'z', 'A'..'Z', '1'..'9');
		for ($i = 0; $i < 15; $i++) {
			$randum_num = int(rand($#passset + 1));
			$session .= @passset[$randum_num];
		}
	
		$user_data[2] = "$time";
		if ($username eq "demo") {
			$session = "GX4bh9GWsh2GznO"
		}
		$user_data[3] = "$session";

		$user = join("\|",@user_data);	
	}
	print ADMIN "$user\n";	
}
close ADMIN;

unless ($right_password) { &error("Incorrect Password"); }

$p_header=1;		
print "Set-Cookie: aliasadmin=$username|$session|$time\;\n";
print "Content-type: text/html\n\n";

&main_admin;
exit;
}


###### VERIFY USER AND COOKIE -- SET NEW COOKIE ######
sub log {

my $account = $INPUT{'username'};
$username = $INPUT{'username'};

if ($ENV{'HTTP_COOKIE'}) {
	$the_cook =$ENV{'HTTP_COOKIE'};
	@cook_parts = split(/\;/,$the_cook);
	foreach $part(@cook_parts) {
		$part =~ s/^ //;
		if ($part =~ /^aliasadmin/) {
			$the_cook = $part;
			$the_cook =~ s/.*?=//;
		}
	}
	@cook = split(/\|/,$the_cook);
	$cook_account = $cook[0];
	$cook_rand = $cook[1];
	$log_time = $cook[2];
	$ses_len = $time - $log_time;
	
	if ($cook_account ne $account) { &pretty_error("Username listed in cookie and one provided are different"); }
	if ($ses_len > 1800) { &pretty_error("Session has expired, please log in again"); }
}
else {
	 &pretty_error("No cookie found - Please login in");
}

open( ADMIN, ">$Config::path/password.txt") || &error("Writing to $Config::path/password.txt");

$session_error = "Invalid username";

foreach $user(@admin_users) {
	chomp($user);
	@user_data=split(/\|/,$user);
	if ($INPUT{'username'} eq $user_data[0]) {
	
	
		## GENERATE RANDOM SESSION VARIABLE ##
		srand($time);
		$session ="";
		@passset = ('a'..'z', 'A'..'Z', '1'..'9');
		for ($i = 0; $i < 15; $i++) {
			$randum_num = int(rand($#passset + 1));
			$session .= @passset[$randum_num];
		}
	
	
		$ltime = $time - $user_data[2];	
	
		if ($ltime > 1800) { 
			$session_error="Session has expired, please log in again. - passwd";
			print ADMIN "$user\n";
			next;
		}
		if ($user_data[3] ne $cook_rand) { 
			$session_error="Invalid session, please log in again"; 
			print ADMIN "$user\n";
			next;
		}
		
		$session_error='';
		$user_data[2] = "$time";
		$access_level=$user_data[4];
		$user = join("\|",@user_data);
	
	}
	print ADMIN "$user\n";	
}
close (ADMIN);

if ($session_error) {
	&error("$session_error");
}

$p_header=1;
print "Set-Cookie: aliasadmin=$username|$cook_rand|$time\;\n";
print "Content-type: text/html\n\n";

}




#### FORWARD TO NEW LOCATION #####
sub location {
	my($location) = @_;
	print "Location: $location \n\n";
	exit;
}


########## DISPLAY LOGIN SCREEN ##########
sub print_login {

$message = $_[0];

unless($p_header) { 
	print "Content-type: text/html\n\n";
	$p_header=1;
}

if ($message) { $message = "<BR><BR><CENTER><FONT FACE=arial size=-1><B>$message</B></FONT>"; }

$css_font = "<font face=arial size=-1>";

print <<EOF;
<HTML<HEAD><TITLE>Welcome to Alias-Mail</TITLE></HEAD>
<BODY bgcolor=white link=blue vlink=blue alink=blue><CENTER>
$message
<BR><BR>
<FORM METHOD=POST ACTION="$files::admin">
<TABLE cellspacing=0 border=1 align=center><TR><TD><table cellspacing=0 cellpadding=5 border=0 bgcolor="#C0C0C0" align=center width=400>
<TR bgcolor="DARKSLATEBLUE"><TD colspan=2><font color=white face=arial size=-1><B>&nbsp;&nbsp;Alias Mail</TD></TR>
<TR><TD align=left>
$css_font
<B>Username:</B></FONT></TD><TD width=100%>
<INPUT TYPE="TEXT" NAME="username" VALUE="" size=15>
</TD>
</TR>
<TR><TD align=left>
$css_font
<B>Password:&nbsp;&nbsp;</B></FONT></TD><TD width=100%>
<INPUT TYPE="PASSWORD" NAME="password" VALUE="" size=15> &nbsp;&nbsp; <INPUT TYPE="SUBMIT" NAME="inital" VALUE="Log in">
<INPUT TYPE="HIDDEN" NAME="inital" Value="Hit Return">
</TD>
</TR>
</TABLE></TD></TR></TABLE></FORM>
<TABLE cellspacing=0 border=1 align=center><TR><TD><table cellspacing=0 cellpadding=5 border=0 bgcolor="#C0C0C0" align=center width=400>
<TR bgcolor="DARKSLATEBLUE"><TD><font color=white face=arial size=-1><B>&nbsp;&nbsp;Alias Mail Version Info</TD></TR>
<TR><TD align=left>$css_font
<B>Current Version:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
$version</B>
EOF

$ua = $ENV{'HTTP_USER_AGENT'};
if ($ua =~ /Mozilla\/3/i) {
	unless ($ua =~ /MSIE/i) {
print <<EOF;
</TD></TR><TR><TD align=left><font Face=arial size=-1>
<B>Newest Version:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
----
EOF
	}
}
else {
print <<EOF;
<script language="javascript1.1" src="http://alias-mail.com/news/js.js">
</script>
EOF
}
print <<EOF;
</TD></TR>
</TABLE></TD></TR></TABLE>
</FORM>
<!--qaswedfrtgdannypplokijuhyg-->
</BODY></HTML>
EOF
exit;
}


########## HEADER FOOTER ##########
sub Header {

my ($cellpadding) = @_;
## TIM'S FAKE CSS FOR CGI ##
$css_font = "<FONT FACE=\"ARIAL\" SIZE=\"-1\">";

unless ($free_name) {
	$free_names = "Alias Mail";
}
else {
	$free_names = $free_name;
}

print <<EOF;

<HTML>
<HEAD>
        <TITLE>$free_names</TITLE>
</HEAD>
<BODY bgcolor=white TEXT="#000000" LINK="#336699" VLINK="#336699" ALINK="#336699">
<table border=0 cellpadding=0 cellspacing=0 bgcolor=black width=100%>
<TR>
	<TD colspan=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD>
</TR>
<TR>
	<TD width=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD>
	<TD bgcolor="333399" colspan=3>&nbsp; <font face=arial size=+3 color=white><B>$Config::name</B></FONT></TD>
	<TD width=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD>
</TR>
<TR>
<TD colspan=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD>
</TR>
<TR>
<TD width=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD>
<TD bgcolor="LightSteelBlue" valign=top align=center width=130><BR><BR><IMG
SRC="$Config::url_img/admin_menu.gif" width=130 height=331 border=0 alt="" usemap="#menu"></TD>
<TD><img src="$Config::url_img/black.gif" width=5 height=1 border=0></TD>
<TD bgcolor=white width=100% valign=top><BR>

EOF
	
	
}


sub Footer {
print <<EOF;
</TD><TD width=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD></TR>
<TR><TD colspan=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD></TR>
<TR><TD width=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD>
<TD colspan=3 bgcolor=navy align=right><font color=white face=arial size=1>Copyright &copy; 1997-99 <a href="http://solutionscripts.com/"><font color=white>Solution Scripts</FONT></a>.&nbsp;&nbsp;&nbsp;&nbsp;</FONT></TD>
<TD width=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD>
</TR><TR>
<TD colspan=5 height=5><img src="$Config::url_img/black.gif" width=5 height=5 border=0></TD></TR></TABLE>
<map name="menu">
<area shape="rect" coords="0,18,130,37" href="$files::admin?username=$INPUT{'username'}&main_admin=general">
<area shape="rect" coords="0,38,130,57" href="$files::setup?username=$INPUT{'username'}&action=setup">
<area shape="rect" coords="0,58,130,77" href="$files::admin?username=$INPUT{'username'}&features_edit=general">
<area shape="rect" coords="0,78,130,97" href="$files::admin?username=$INPUT{'username'}&features_edit=reserved">
<area shape="rect" coords="0,98,130,117" href="$files::admin?username=$INPUT{'username'}&features_edit=userinfo">
<area shape="rect" coords="0,118,130,137" href="$files::admin?username=$INPUT{'username'}&action=managefiles">

<area shape="rect" coords="0,155,130,174" href="$files::admin?username=$INPUT{'username'}&action=browse">
<area shape="rect" coords="0,175,130,194" href="$files::admin?username=$INPUT{'username'}&action=view_accounts&b_onhold=checked">
<area shape="rect" coords="0,195,130,214" href="$files::admin?username=$INPUT{'username'}&action=view_accounts&b_onhold_approve=checked">
<area shape="rect" coords="0,215,130,234" href="$files::admin?username=$INPUT{'username'}&action=email_all">

<area shape="rect" coords="0,252,130,271" href="$files::admin?username=$INPUT{'username'}&action=housekeeping">
<area shape="rect" coords="0,272,130,291" href="$files::admin?username=$INPUT{'username'}&action=admin_users">
<area shape="rect" coords="0,292,130,311" href="http://alias-mail.com/manual">
<area shape="rect" coords="0,312,130,331" href="http://solutionscripts.com/lounge/alias-mail">

<area shape="default" nohref>
</MAP>
<BR><BR>
EOF
}

sub pretty_error {
unless($p_header) { 
	print "Content-type: text/html\n\n";
	$p_header=1;
}

$error = $_[0] ;
print "$error";
exit;
}	

sub error {
unless($p_header) { 
	print "Content-type: text/html\n\n";
	$p_header=1;
}

$error = $_[0] ;
if ($error == 9) {
print <<EOF;
<html>
<head>
<title>Error</title>
</head>
<body>
<CENTER>
<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 BGCOLOR=#778899 WIDTH=500>
<TR><TD align=center>
<font face=arial size=2 color=white><B>Wrong registration key</B></FONT>
<TABLE CELLPADDING=8 CELLSPACING=0 WIDTH=100% BGCOLOR=white BORDER=0><TR><TD>
<font face="arial" size="1">
The registration key is dynamically created each day and can be obtained from
<a href="http://solutionscripts.com/lounge/homefree/key.cgi"><B>Solution Scripts</B></A>. Make sure the
key you are using is for: <B>$gnow GMT</B>
<BR><BR>
If you have any problems, please send an email to <a href="solutions\@solutionscripts.com"><B>Solution Scripts</B></A>
stating you Alias Mail username and transaction number if you have one. 
</TD></TR></TABLE>
</TD></TR></TABLE>
<BR><BR>
EOF
&Footer;
exit;
}
print <<EOF;
<html>
<head>
<title>Error</title>
</head>
<body>
<TABLE border=1 bgcolor=Gainsboro><TR align=left><TD>
<font face="arial, arial, Geneva" size="1">
<B>Alias Mail Error<BR><BR>
<BR><BR>
<I>$error -- $!</I><BR><BR>
If you are having problems running Alias Mail<BR>
please post a message to the <a href="http://solutionscripts.com/lounge/homefree">Alias Mail Forum</a>
<BR>
</TD></TR></TABLE>
</BODY></HTML>
EOF
exit;
}

sub unauth {
$foot = $_[0];
unless ($foot) { &Header; }
print <<EOF;
<TABLE cellpadding=5 cellspacing=0 border=1 align=center>
<TR><TD align=center><FONT FACE=arial size=-1 color=red><B>
You are unauthorized to enter this section</B></FONT></TD></TR>
</TABLE>
EOF
unless ($foot) { &Footer; }
exit;
}


######### FORMAT TIME ########
sub format_time {

my $time = $_[0];
($tsec,$tmin,$thour,$tmday,$tmon,$tyear,$twday,$tyday,$tisdst) = localtime($time);
$tmon++;
$tyear += 1900;
if ($Config::time eq "euro") {
	$stamp = "$tmday-$tmon-$tyear";
}
else {
	$stamp = "$tmon-$tmday-$tyear";
}
return($stamp);
}

return(1);
